#ifndef VULKANCPPSETUP_UNIFORMBUFFERS_H
#define VULKANCPPSETUP_UNIFORMBUFFERS_H

#include <QVulkanDeviceFunctions>
#include <QVulkanWindow>
#include <vector>

// Note: Switched to push constants, but kept this work
class UniformBuffers {
public:
  explicit UniformBuffers() = default;
  ~UniformBuffers() = default;

  void createBuffers(QVulkanWindow *window, QVulkanDeviceFunctions *devFuncs);
  void destroyBuffers(QVulkanWindow *window,
                      QVulkanDeviceFunctions *devFuncs);

private:
  std::vector<VkBuffer> m_uniformBuffers{};
  std::vector<VkDeviceMemory> m_uniformBuffersMemory{};
};

#endif // VULKANCPPSETUP_UNIFORMBUFFERS_H
