#include "VulkanWindow.h"
#include <QtGui/QGuiApplication>
#include <QtGui/QVulkanWindow>

int main(int argc, char **argv) {
  QGuiApplication app(argc, argv);

  QVulkanInstance inst;
  QByteArrayList layers{"VK_LAYER_KHRONOS_validation"};
  inst.setLayers(layers);
  if (!inst.create()) {
    qFatal("Could not create Vulkan instance, code %d", inst.errorCode());
  }
  for (const auto& layer : layers) {
    if (!inst.layers().contains(layer)) {
      qFatal("Layer not available: %s", layer.toStdString().c_str());
    }
  }
  VulkanWindow window{};
  window.setVulkanInstance(&inst);
  window.resize(800, 600);
  window.show();

  return QGuiApplication::exec();
}
